package com.smppw.analysis.client;

import com.smppw.analysis.application.dto.performance.HeadIndicatorParams;
import com.smppw.analysis.application.dto.performance.IndicatorParams;
import com.smppw.analysis.application.dto.performance.TrendParams;
import com.smppw.analysis.application.service.performance.CommonService;
import com.smppw.analysis.application.service.performance.PerformanceService;
import com.smppw.common.pojo.ResultVo;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

@RestController
@RequestMapping("/v1/api/fund")
public class FundPerformanceApi {
    private final CommonService commonService;
    private final PerformanceService performanceService;

    public FundPerformanceApi(CommonService commonService, PerformanceService performanceService) {
        this.commonService = commonService;
        this.performanceService = performanceService;
    }

    @GetMapping("/indicator")
    public ResultVo<Map<String, Object>> indicator(IndicatorParams params) {
        Map<String, Object> data = this.performanceService.calcIndicators(params);
        return ResultVo.ok(data);
    }

    @GetMapping("/trend")
    public ResultVo<Map<String, Object>> trend(TrendParams params) {
        Map<String, Object> data = this.performanceService.trend(params);
        return ResultVo.ok(data);
    }

    @GetMapping("/head/indicator")
    public ResultVo<Map<String, Object>> headIndicator(HeadIndicatorParams params) {
        Map<String, Object> indicator = this.commonService.getIndicator(params);
        return ResultVo.ok(indicator);
    }
}
