package com.smppw.analysis.domain.event;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;

import java.util.function.Function;

@Component
public class CacheEventListener {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @EventListener(value = {SaveCacheEvent.class})
    public void saveCache(SaveCacheEvent<Object> event) {
        Function<Object, Boolean> function = event.getFunction();
        Boolean apply = function.apply(event.getTarget());
        if (apply == null || apply == Boolean.FALSE) {
            logger.warn("缓存保存失败！");
        }
    }
}
