package com.smppw.analysis.domain.event;

import org.springframework.context.ApplicationEvent;

import java.util.function.Function;

public class SaveCacheEvent<T> extends ApplicationEvent {
    private final T target;
    private final Function<T, Boolean> function;

    public SaveCacheEvent(Object source, T target, Function<T, Boolean> function) {
        super(source);
        this.target = target;
        this.function = function;
    }

    public T getTarget() {
        return target;
    }

    public Function<T, Boolean> getFunction() {
        return function;
    }
}
